\\ Copyright 2015, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.




check_equal(got,want) =
{
  if(got!=want, print("wrong\n","got\n",got,"\nwant\n",want);
                quit(1),
                print("ok"));
}


\\ my $fsm = { 0  => { 0 => 0,  1 => 1,  2 => 2 },
\\             1  => { 0 => 1,  1 => 4,  2 => 2 },
\\             2  => { 0 => 6,  1 => 1,  2 => 2 },
\\             3  => { 0 => 7,  1 => 4,  2 => 2 },
\\             4  => { 0 => 1,  1 => 4,  2 => 5 },
\\             5  => { 0 => 7,  1 => 4,  2 => 5 },
\\             6  => { 0 => 6,  1 => 3,  2 => 6 },
\\             7  => { 0 => 7,  1 => 5,  2 => 6 },
\\           };

\\     0  1  2  3  4  5  6  7
mt = {[ 1, 1, 1, 0, 0, 0, 0, 0;   \\ 0
        0, 1, 1, 0, 1, 0, 0, 0;   \\ 1
        0, 1, 1, 0, 0, 0, 1, 0;   \\ 2
        0, 0, 1, 0, 1, 0, 0, 1;   \\ 3
        0, 1, 0, 0, 1, 1, 0, 0;   \\ 4
        0, 0, 0, 0, 1, 1, 0, 1;   \\ 5
        0, 0, 0, 1, 0, 0, 2, 0;   \\ 5
        0, 0, 0, 0, 0, 1, 1, 1    \\ 7
      ]};
m = mattranspose(mt);
initial = [1;0;0;0; 0;0;0;0];

v = initial;
for(k=0,5, v = m*v; print(v))

ES(s,k) = (m^k*initial)[s,1];
for(s=1,8, for(k=0,8, print1(ES(s,k),",")); print())

\\ mat_vselect(len,n,pos=n) = my(m=matrix(len,len)); m[pos,n]=1; m;
\\ mat_vselect(8, 2, 1)
\\ 
\\ mat_torun(m,n) =
\\ {
\\   my(s = matsize(m), len = s[1]);
\\   sum(i=1,len, mat_vselect(len, n, i) * m^(i-1));
\\ }
\\ print("torun")
\\ t = mat_torun(m,2)
\\ print("det ", matdet(t))
\\ print("kern")
\\ matker(t)
\\ mat_torun(m,2)*[ 1;0;0;0; 0;0;0;0 ]
\\ 
\\ mat_recurrence(m,n) = my(torun = mat_torun(m,n)); torun * m * torun^-1;
\\ mat_recurrence(m,1)
\\ r = mat_recurrence(m,2)
\\ mat_recurrence(m,3)
\\ 
\\ v = mat_torun(m,2)*[ 1;0;0;0; 0;0;0;0 ]
\\ for(k=0,5, v = r*v; print(v))



\\ \\     0  1  2  3  4  5  6  7
\\ m = {[ 1, 1, 1, 0, 0, 0, 0, 0;   \\ 0
\\        0, 1, 1, 0, 1, 0, 0, 0;   \\ 1
\\        0, 1, 1, 0, 0, 0, 1, 0;   \\ 2
\\        0, 0, 1, 0, 1, 0, 0, 1;   \\ 3
\\        0, 1, 0, 0, 1, 1, 0, 0;   \\ 4
\\        0, 0, 0, 0, 1, 1, 0, 1;   \\ 5
\\        0, 0, 0, 1, 0, 0, 2, 0;   \\ 5
\\        0, 0, 0, 0, 0, 1, 1, 1    \\ 7
\\      ]};
\\ gB(x) = x*(gA(x) + gB(x) + gC(x) + gE(x)) + B(0)
mx = matid(matsize(m)[1]) - m*x
g = matsolve(mx,initial)

\\ m = [0,1;1,1];
\\ mx = m - matid(matsize(m)[1])*x
\\ matsolve(mx,[0;1])

\\ matrix(8,1, i,j, factor(denominator(g[i,1]))[,1])

read("../tools/pol-pfrac.gp")
matrix(8,1, i,j, pol_partial_fractions(g[i,1]))

gf_terms(g,n) = \
  my(x = variable(g), \
     zeros = min(n,valuation(g,x)), \
     v = Vec(g + O(x^n))); \
  if(zeros>=0, concat(vector(zeros,i,0), v), \
               v[-zeros+1 .. #v]);
gf_terms(g[1,1], 8)
gf_terms(g[2,1], 8)
gf_terms(g[3,1], 8)
gf_terms(g[4,1], 8)
gf_terms(g[5,1], 8)
gf_terms(g[6,1], 8)
gf_terms(g[7,1], 8)
gf_terms(g[8,1], 8)

\\ k= 0    1   0   0   0   0   0   0   0
\\ k= 1    1   1   1   0   0   0   0   0
\\ k= 2    1   3   3   0   1   0   1   0
\\ k= 3    1   8   7   1   4   1   5   0
\\ k= 4    1  20  17   5  14   5  17   2
\\ k= 5    1  52  43  17  44  21  53  12
\\ k= 6    1 140 113  53 134  77 161  50

\\ denoms (6*x^2 - 5*x + 1)     2,3,6,8
\\ denoms (3*x^2 - 4*x + 1)     4,-5,7


check_equal(g[2,1], (-2*x^4 - x^3 - 2*x^2 + x)/(6*x^2 - 5*x + 1))
check_equal(g[2,1], - 35/54 - 4/9*x - 1/3*x^2  + (1/2)/(1 - 2*x) + (4/27)/(1 - 3*x))
check_equal(g[2,1], \
           (1/2 + 4/27 - 35/54) + (1 + 4/9 - 4/9)*x + (2 + 4/3 - 1/3)*x^2 \
           + 4*x^3/(1 - 2*x) + 27*x^3*(4/27)/(1 - 3*x))
check_equal(g[2,1], x + 3*x^2   + 4*x^3*( 1/(1 - 2*x) + 1/(1 - 3*x) ))
B(k) = if(k==0,0, k==1,1, k==2,3, 4*(2^(k-3) + 3^(k-3)));

check_equal(g[3,1], (-2*x^3 - 2*x^2 + x)/(6*x^2 - 5*x + 1))
check_equal(g[3,1], -1/3*x - 11/18 -1/(4*x - 2) -1/(27*x - 9))
check_equal(g[3,1], - 11/18 -1/3*x  + (1/2)/(1-2*x) + (1/9)/(1-3*x))
check_equal(g[3,1], 1/2- 11/18 + (1-1/3)*x  + 4*x^2*(1/2)/(1-2*x) + (1/9)/(1-3*x))
check_equal(g[3,1], 1/2 + 1/9- 11/18 + (1 + 1/3 - 1/3)*x  + 4*x^2*(1/2)/(1-2*x) + 9*x^2*(1/9)/(1-3*x))
check_equal(g[3,1], x  + x^2*( 2/(1-2*x) + 1/(1-3*x) ))
C(k) = if(k==0,0, k==1,1, 2*2^(k-2) + 3^(k-2));

check_equal(g[4,1], (x^4 + x^3)/(3*x^2 - 4*x + 1))
check_equal(g[4,1], x*g[7,1])
D(k) = if(k==0,0, G(k-1));

check_equal(g[5,1], (-x^4 - x^2)/(-3*x^2 + 4*x - 1))
check_equal(g[5,1], 1/3*x^2 + 4/9*x + 22/27 + 1/(x - 1) -5/(81*x - 27))
check_equal(g[5,1], + 22/27 + 4/9*x + 1/3*x^2 - 1/(1-x) + 5/27/(1-3*x))
check_equal(g[5,1], + 5/27+22/27 + (5/9+4/9)*x + (5/3+1/3)*x^2 - 1/(1-x) + 27*x^3*5/27/(1-3*x))
check_equal(g[5,1], x^2 + x^3*( -1/(1-x) + 5/(1-3*x) ))
E(k) = if(k==0,0, k==1,0, k==2,1, -1 + 5*3^(k-3));

check_equal(g[6,1], (-2*x^5 + x^4 - x^3)/(6*x^3 - 11*x^2 + 6*x - 1))
check_equal(g[6,1], vecsum([-1/3*x^2 - 4/9*x - 35/54, -1/(x - 1), 1/(4*x - 2), -4/(81*x - 27)]))
check_equal(g[6,1], - 35/54 - 4/9*x  -1/3*x^2  + 1/(1-x) - (1/2)/(1-2*x) + 4/27/(1-3*x))
check_equal(g[6,1], (-1/2- 35/54) + (-2*1/2 - 4/9)*x + (-4*1/2 -1/3)*x^2  + 1/(1-x) - 8*x^3*(1/2)/(1-2*x) + 4/27/(1-3*x))
check_equal(g[6,1], (4/27-1/2- 35/54) + (4/9-2*1/2 - 4/9)*x + (4/3-4*1/2 -1/3)*x^2  + 1/(1-x) - 8*x^3*(1/2)/(1-2*x) + 27*x^3*4/27/(1-3*x))
check_equal(g[6,1], -1 + -1*x + -1*x^2  + 1/(1-x) - x^3*4/(1-2*x) + x^3*4/(1-3*x))
check_equal(g[6,1], x^3*( 1/(1-x) - 4/(1-2*x) + 4/(1-3*x) ))
F(k) = if(k<3,0, 1 - 4*2^(k-3) + 4*3^(k-3));

check_equal(g[7,1], (x^3 + x^2)/(3*x^2 - 4*x + 1))
check_equal(g[7,1], vecsum([1/3*x + 7/9, 1/(x - 1), -2/(27*x - 9)]))
check_equal(g[7,1],  + 7/9 + 1/3*x - 1/(1-x)  + 2/9/(1-3*x))
check_equal(g[7,1],  (2/9+ 7/9) + (2/3+1/3)*x - 1/(1-x)  + 9*x^2*2/9/(1-3*x))
check_equal(g[7,1],  x^2*( -1/(1-x) + 2/(1-3*x) ))
G(k) = if(k<2,0, -1 + 2*3^(k-2));

check_equal(g[8,1], -2*x^4/(6*x^3 - 11*x^2 + 6*x - 1))
check_equal(g[8,1], vecsum([-1/3*x - 11/18, -1/(x - 1), 1/(4*x - 2), -1/(27*x - 9)]))
check_equal(g[8,1], - 11/18 -1/3*x + 1/(1-x) - 1/2/(1-2*x) + 1/9/(1-3*x))
check_equal(g[8,1], (1/9- 11/18)+ (1/3-1/3)*x + 1/(1-x) - 1/2/(1-2*x) + 9*x^2*1/9/(1-3*x))
check_equal(g[8,1], -1/2 + 1/(1-x) - 1/2/(1-2*x) + 9*x^2*1/9/(1-3*x))
check_equal(g[8,1], -1/2-1/2 - 1*x + 1/(1-x) - 4*x^2*1/2/(1-2*x) + 9*x^2*1/9/(1-3*x))
check_equal(g[8,1], -1 - x + 1/(1-x) - x^2*2/(1-2*x) + x^2*1/(1-3*x))
check_equal(g[8,1], x^2*( 1/(1-x) - 2/(1-2*x) + 1/(1-3*x) ))
H(k) = if(k<2,0, 1 - 2*2^(k-2) + 3^(k-2));
H(k) = if(k==0,0, k==1,0, k==2,0, 1 - 4*2^(k-3) + 3*3^(k-3));

check_equal(vector(100,k,my(k=k-1); B(k)), gf_terms(g[2,1],100))
check_equal(vector(100,k,my(k=k-1); C(k)), gf_terms(g[3,1],100))
check_equal(vector(100,k,my(k=k-1); D(k)), gf_terms(g[4,1],100))
check_equal(vector(100,k,my(k=k-1); E(k)), gf_terms(g[5,1],100))
check_equal(vector(100,k,my(k=k-1); F(k)), gf_terms(g[6,1],100))
check_equal(vector(100,k,my(k=k-1); G(k)), gf_terms(g[7,1],100))
check_equal(vector(100,k,my(k=k-1); H(k)), gf_terms(g[8,1],100))


\\ B(k) =
\\ {
\\   if(k==0, -35/54, 0)
\\   + if(k==1, -4/9, 0)
\\   + if(k==2, -1/3, 0)
\\   + 2^(k-1) + (4/9)*3^(k-1);
\\ }
\\ vector(13,k,my(k=k-1); B(k))

vector(13,k,my(k=k-1); H(k))

